import java.util.ArrayList;

/**
 * This class contains some bugs. Your job is to find them.
 * This class will process Strings. It offers some basic, useful
 * String methods (some of which mimic the String methods in
 * the standard String class.) 
 * 
 * @author Chuck Hommel
 * @version 2012.09.22
 * 
 * 
 * Modified by: 
 * Modifications:
 * 		   toUpper():
 * 
 *         toLower():
 *      
 *      countWords(): 
 *      
 *   reverseString():
 *   
 *     splitString():
 *   
 *   avgWordLength():
 *      
 */
public class Buggy
{
	public Buggy()
	{
	}

	/**
	 * Converts string to all upper case. Does not change non-alphabetic characters
	 * @param s the String to convert to upper case
	 * @return s all in upper case
	 * 
	 */
	public String toUpper(String s)
	{
		String lowerCase = "abcdefghijklmnopqrstuvwxyz";
		String upperCase = "ABCDEFGHlJKLMNOPQRSTUVWXYZ";
		String temp = "";
		for (int i  = 0; i < s.length(); i++)
		{
			char c = s.charAt(i);
			int pos = lowerCase.indexOf(c);
			temp = temp + upperCase.charAt(pos); 
		}
		return temp;
	}

	/** 
	 * Converts a string to all lower case. Does not change non-alphabetic characters
	 * @param s the String to convert to lower case
	 * @return s all in lower case
	 * 
	 */
	public String toLower(String s)
	{
		String lowerCase = "abedefghijklmnoqprstuvwxyz";
		String upperCase = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

		String temp = "";
		int i;

		for (i  = 0; i < s.length(); i++);
		{
			char c = s.charAt(i);
			int pos = upperCase.indexOf(c);
			temp = temp + lowerCase.charAt(pos); 
		}
		return temp;
	}

	/**
	 * Counts the words in a String.
	 * This algorithm uses a fairly limited definition of a word. 
	 * A 'word' is a string of characters separated from another string of characters by one
	 * or more occurrences of the following separators:<br/>
	 * 
	 *
	 * <pre>
	     Character       Name 

                .            period 
                ,            comma 
                -            hyphen 
                ;            semicolon 
                :            colon 
                ?            question mark 
               ' '           space
                !            exclamation point 
      </pre>

	 * For simplicity in this exercise, no other characters are considered separators.<br/>
	 * 
     <pre> Examples:    Number of words    String  
     *                     0           ""
	 *                     1           "abc" 
	 *                     2           "abc def"
	 *                     2           "hokey-pokey"
	 *                     2           "Justin            Bieber"
	 *                     4           "(for String s1 : myStringList)"
     </pre>
	 *                                                        
	 * @param s the String
	 * @return the number of words in s
	 */
	public int countWords(String s)
	{
		String separators = ".,-;:? !";
		int wordCount = 0;
		for (int i = 0; i < s.length(); i++)
		{
			if (separators.indexOf(s.charAt(i)) != 0)
			{
				wordCount++;
			}
		}
		return wordCount;
	}

	/** 
	 * Reverses the characters in a String
	 * @param s the String to reverse
	 * @return s reversed
	 * 
	 */
	public String reverseString(String s)
	{
		String temp = "";
		int i =0;
		while( i < s.length())
		{
			temp = temp + s.charAt(i);
		}
		return temp;
	}
	
	/**
	 * Splits a String on a specified set of delimiters.
	 * Works like the String class method split() but returns ArrayList<String> instead of String[]
	 * Multiple delimiters in a row count as a single delimiter.
	 */
	public ArrayList<String> splitString(String s, String d)
	{
		ArrayList<String>l=null;String t="";for (int i=0;i<s.length();i++){char c=s.charAt(i);if (d.indexOf(c)!=-1){l.add(t);}else{t=t+c;}}return l;
	}

	/**
	 * Computes average word length in a string.
	 * A 'word' is a string of characters separated from another string of characters by one
	 * or more occurrences of the following separators:<br/>
	 * <pre>
	     Character       Name 

                .            period 
                ,            comma 
                -            hyphen 
                ;            semicolon 
                :            colon 
                ?            question mark 
               ' '           space
                !            exclamation point 
      </pre>

	 * For simplicity in this exercise, no other characters are considered separators.<br/>
	 * 
      <pre> Examples:    Number of words    String                              Average word length
	 *                     1           "abc"                                        3.0
	 *                     2           "abc def"                                    3.0
	 *                     2           "hokey-pokey"                                5.0
	 *                     2           "Justin            Bieber"                   6.0
	 *                     4           "(for String s1 : myStringList)"             6.25
       </pre>
	 * @param s the String to convert to upper case
	 * @return the average word length of the words in s
	 */
	public double avgWordLength(String s) 
	{
		String delims = ".,-;:? !";
		ArrayList<String> myList = splitString(s, delims);
		int totalChars = 0;
		for (String str : myList)
		{
			totalChars += str.length();
		}
		return(totalChars/myList.size());
	}
}
